//  BMPx - The Dumb Music Player
//  Copyright (C) 2005 BMPx development team.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_LIBRARY_UI_MERGE_HPP 
#define BMP_LIBRARY_UI_MERGE_HPP

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <glibmm.h>
#include <glibmm/markup.h>
#include <gtkmm.h>
#include <libglademm.h>

#include "amazon.hpp"
#include "library.hpp"
#include "musicbrainz_ws.hpp"

namespace Bmp
{
  class LibraryUIMergeDialog
    : public Gtk::Dialog
  {
    public:

	LibraryUIMergeDialog (BaseObjectType                       *cobject,
			      const Glib::RefPtr<Gnome::Glade::Xml> &xml);

	static LibraryUIMergeDialog*
	create ();

	virtual int
	run (const MusicBrainzWS::MB_Releases& releases);

	// The release chosen last
	MusicBrainzWS::MB_Release selected;

    private:

      void
      artist_changed ();

      void
      album_changed ();

      // ColumnRecords
      class ColumnRecordArtist
	  : public Gtk::TreeModel::ColumnRecord
      {
	public:

	  Gtk::TreeModelColumn<Glib::ustring> name;
	  Gtk::TreeModelColumn<std::string>   id; // Artist ID

	  ColumnRecordArtist ()
	  {
	    add (name);
	    add (id);
	  }
      };
      ColumnRecordArtist artists;

      class ColumnRecordAlbum
	  : public Gtk::TreeModel::ColumnRecord
      {
	public:

	  Gtk::TreeModelColumn<Glib::ustring> name;
	  Gtk::TreeModelColumn<std::string>   id; // Release ID

	  ColumnRecordAlbum ()
	  {
	    add (name);
	    add (id);
	  }
      };
      ColumnRecordAlbum albums;


      typedef std::map < std::string, MusicBrainzWS::MB_Release > ReleaseMap;
      ReleaseMap merge_releases;

      typedef std::vector < std::string > ReleaseIds;
      typedef std::map < std::string, ReleaseIds > ArtistReleaseMap; 
      ArtistReleaseMap  merge_artist_release_map;

      // GladeXML+Widgets
      Glib::RefPtr<Gnome::Glade::Xml> ref_xml;

      Gtk::ComboBox		    *merge_cb_artist;
      Gtk::ComboBox		    *merge_cb_album;
      Glib::RefPtr<Gtk::ListStore>   merge_cb_artist_store;
      Glib::RefPtr<Gtk::ListStore>   merge_cb_album_store;

      Gtk::Image		    *merge_coverart;
      Glib::RefPtr<Gdk::Pixbuf>	     coverart_default;

      Gtk::Entry		    *merge_album;
      Gtk::Entry		    *merge_artist;
      Gtk::Entry		    *merge_artist_id;
      Gtk::Entry		    *merge_ASIN;
      Gtk::Entry		    *merge_release_ID;
      Gtk::Entry		    *merge_score;
  };
}
#endif
