#ifndef BMP_SHELL_HPP
#define BMP_SHELL_HPP

#include <gtkmm.h>
#include <mcs/mcs.h>
#include <mcs/gtk-bind.h>

#include "winamp2_skin.hpp"
#include "winamp2_main.hpp"
#include "winamp2_playlist.hpp"

// Stock icons
#  define BMP_STOCK_LIBRARY	  "bmp-stock-library"
#  define BMP_STOCK_STREAMS	  "bmp-stock-streams"
#  define BMP_STOCK_ABOUT	  "bmp-stock-about"
#  define BMP_STOCK_PREFERENCES	  "bmp-stock-preferences"
#  define BMP_STOCK_BOOKMARKS	  "bmp-stock-bookmarks"
#  define BMP_STOCK_XIPH	  "bmp-stock-xiph"
#  define BMP_STOCK_SHOUTCAST	  "bmp-stock-shoutcast"

namespace Bmp
{

  extern Glib::RefPtr<Gtk::UIManager>	  ui_manager;
  extern Glib::RefPtr<Gtk::ActionGroup>   actions;
  extern Glib::RefPtr<Gtk::ActionGroup>   actions_toggle; 
  extern BmpWinamp2Skin			 *winamp2_skin;
  extern BmpWindowMain			 *w_main;
  extern BmpWindowPlaylist		 *w_playlist;
  extern Mcs::Bind			 *mcs_bind;

  void
  shell_init ();

  void
  shell_stop ();

  bool
  shell_running ();

  void
  raise_windows ();

}

#endif
